<?php

/**
 * Hierarchy plugin.
 *
 *
 * Created: 2007-02-03
 * Last update: 2007-02-13
 *
 * @link http://deboutv.free.fr/mantis/
 * @author DEBOUT Vincent  <deboutv@free.fr>
 */

define( 'PLUGINS_HIERARCHY_SHOW_MANAGERS_DEFAULT', OFF );
define( 'PLUGINS_HIERARCHY_SHOW_DEVELOPERS_DEFAULT', OFF );
define( 'PLUGINS_HIERARCHY_TITLE_DEFAULT', 'Bugtracker Hierarchy' );

function display_manager_cell( $p_project_id ) {
    $t_projects = array();
    $t_project_elt['id'] = $p_project_id;
    $t_project_elt['level'] = 0;
    $t_projects[] = $t_project_elt;

    $t_subproject = project_hierarchy_get_subprojects( $p_project_id );
    $t_subproject = array_reverse( $t_subproject );
    $t_level = 1;
    $t_level_count = array();
    $t_level_count[$t_level] = 0;
    $t_parse = count( $t_subproject );
    $t_max = $t_parse;
    while( $t_parse != -1 ) {
	if ( isset( $t_subproject[$t_parse] ) ) {
	    $t_project_elt['id'] = $t_subproject[$t_parse];
	    $t_project_elt['level'] = $t_level;
	    $t_projects[] = $t_project_elt;
	    $t_id = $t_subproject[$t_parse];
	    if ( $t_level_count[$t_level] != 0 ) {
		$t_level_count[$t_level]--;
		if ( $t_level_count[$t_level] == 0 ) {
		    $t_level--;
		}
	    }
	    unset( $t_subproject[$t_parse] );
	    $t_new_array = project_hierarchy_get_subprojects( $t_id );
	    $t_new_array = array_reverse( $t_new_array );
	    if ( count( $t_new_array ) != 0 ) {
		$t_level++;
		$t_level_count[$t_level] = count( $t_new_array );
		$t_parse = $t_max;
		foreach( $t_new_array as $t_elt ) {
		    array_push( $t_subproject, $t_elt );
		    $t_parse++;
		}
		$t_max = $t_parse;
	    }
	}
	$t_parse--;
    }

    foreach( $t_projects as $t_project ) {
	for( $i=0;$i<$t_project['level'];$i++ ) {
	    echo '&nbsp; ';
	}
	echo '<b>' . string_display( project_get_field( $t_project['id'], 'name' ) ) . ":</b><br>\n";
	$t_manager_id = project_get_all_user_rows( $t_project['id'], MANAGER );
	foreach( $t_manager_id as $t_man_id ) {
	    $t_user_name = user_get_name( $t_man_id['id'] );
            for( $i=0;$i<$t_project['level'];$i++ ) {
                echo '&nbsp; ';
            }
            print "&nbsp; - $t_user_name<br />\n";
	}
    }
}

function display_developer_cell( $p_project_id ) {
    $t_projects = array();
    $t_project_elt['id'] = $p_project_id;
    $t_project_elt['level'] = 0;
    $t_projects[] = $t_project_elt;

    $t_subproject = project_hierarchy_get_subprojects( $p_project_id );
    $t_subproject = array_reverse( $t_subproject );
    $t_level = 1;
    $t_level_count = array();
    $t_level_count[$t_level] = 0;
    $t_parse = count( $t_subproject );
    $t_max = $t_parse;
    while( $t_parse != -1 ) {
	if ( isset( $t_subproject[$t_parse] ) ) {
	    $t_project_elt['id'] = $t_subproject[$t_parse];
	    $t_project_elt['level'] = $t_level;
	    $t_projects[] = $t_project_elt;
	    $t_id = $t_subproject[$t_parse];
	    if ( $t_level_count[$t_level] != 0 ) {
		$t_level_count[$t_level]--;
		if ( $t_level_count[$t_level] == 0 ) {
		    $t_level--;
		}
	    }
	    unset( $t_subproject[$t_parse] );
	    $t_new_array = project_hierarchy_get_subprojects( $t_id );
	    $t_new_array = array_reverse( $t_new_array );
	    if ( count( $t_new_array ) != 0 ) {
		$t_level++;
		$t_level_count[$t_level] = count( $t_new_array );
		$t_parse = $t_max;
		foreach( $t_new_array as $t_elt ) {
		    array_push( $t_subproject, $t_elt );
		    $t_parse++;
		}
		$t_max = $t_parse;
	    }
	}
	$t_parse--;
    }

    foreach( $t_projects as $t_project ) {
	for( $i=0;$i<$t_project['level'];$i++ ) {
	    echo '&nbsp; ';
	}
	echo '<b>' . string_display( project_get_field( $t_project['id'], 'name' ) ) . ":</b><br>\n";
	$t_manager_id = project_get_all_user_rows( $t_project['id'], DEVELOPER );
	foreach( $t_manager_id as $t_man_id ) {
	    $t_user_name = user_get_name( $t_man_id['id'] );
            for( $i=0;$i<$t_project['level'];$i++ ) {
                echo '&nbsp; ';
            }
            print "&nbsp; - $t_user_name<br />\n";
	}
    }
}

function display_description_cell( $p_project_id ) {
    $t_projects = array();
    $t_project_elt['id'] = $p_project_id;
    $t_project_elt['level'] = 0;
    $t_projects[] = $t_project_elt;

    $t_subproject = project_hierarchy_get_subprojects( $p_project_id );
    $t_subproject = array_reverse( $t_subproject );
    $t_level = 1;
    $t_level_count = array();
    $t_level_count[$t_level] = 0;
    $t_parse = count( $t_subproject );
    $t_max = $t_parse;
    while( $t_parse != -1 ) {
	if ( isset( $t_subproject[$t_parse] ) ) {
	    $t_project_elt['id'] = $t_subproject[$t_parse];
	    $t_project_elt['level'] = $t_level;
	    $t_projects[] = $t_project_elt;
	    $t_id = $t_subproject[$t_parse];
	    if ( $t_level_count[$t_level] != 0 ) {
		$t_level_count[$t_level]--;
		if ( $t_level_count[$t_level] == 0 ) {
		    $t_level--;
		}
	    }
	    unset( $t_subproject[$t_parse] );
	    $t_new_array = project_hierarchy_get_subprojects( $t_id );
	    $t_new_array = array_reverse( $t_new_array );
	    if ( count( $t_new_array ) != 0 ) {
		$t_level++;
		$t_level_count[$t_level] = count( $t_new_array );
		$t_parse = $t_max;
		foreach( $t_new_array as $t_elt ) {
		    array_push( $t_subproject, $t_elt );
		    $t_parse++;
		}
		$t_max = $t_parse;
	    }
	}
	$t_parse--;
    }

    foreach( $t_projects as $t_project ) {
	for( $i=0;$i<$t_project['level'];$i++ ) {
	    echo '&nbsp; ';
	}
	echo '<b>' . string_display( project_get_field( $t_project['id'], 'name' ) ) . ":</b>\n";
	for( $i=0;$i<$t_project['level'];$i++ ) {
	    echo '&nbsp; ';
	}
	echo '&nbsp;<p>' . string_display( project_get_field( $t_project['id'], 'description' ) ) . '</p>' . "\n";
    }
}

function display_project_cell( $p_project_id ) {
    $t_projects = array();
    $t_project_elt['id'] = $p_project_id;
    $t_project_elt['level'] = 0;
    $t_projects[] = $t_project_elt;

    $t_subproject = project_hierarchy_get_subprojects( $p_project_id );
    $t_subproject = array_reverse( $t_subproject );
    $t_level = 1;
    $t_level_count = array();
    $t_level_count[$t_level] = 0;
    $t_parse = count( $t_subproject );
    $t_max = $t_parse;
    while( $t_parse != -1 ) {
	if ( isset( $t_subproject[$t_parse] ) ) {
	    $t_project_elt['id'] = $t_subproject[$t_parse];
	    $t_project_elt['level'] = $t_level;
	    $t_projects[] = $t_project_elt;
	    $t_id = $t_subproject[$t_parse];
	    if ( $t_level_count[$t_level] != 0 ) {
		$t_level_count[$t_level]--;
		if ( $t_level_count[$t_level] == 0 ) {
		    $t_level--;
		}
	    }
	    unset( $t_subproject[$t_parse] );
	    $t_new_array = project_hierarchy_get_subprojects( $t_id );
	    $t_new_array = array_reverse( $t_new_array );
	    if ( count( $t_new_array ) != 0 ) {
		$t_level++;
		$t_level_count[$t_level] = count( $t_new_array );
		$t_parse = $t_max;
		foreach( $t_new_array as $t_elt ) {
		    array_push( $t_subproject, $t_elt );
		    $t_parse++;
		}
		$t_max = $t_parse;
	    }
	}
	$t_parse--;
    }

    $t_current_project_id = helper_get_current_project();
    if ( $t_current_project_id == 0 ) {
        $t_current_project_name = lang_get( 'all_projects' );
    } else {
        $t_current_project_name = project_get_field( $t_current_project_id, 'name' );
    }

    foreach( $t_projects as $t_project ) {
	$t_title = lang_get( 'plugins_hierarchy_change_current_project' );
        $t_title = str_replace( '%%current_project%%', $t_current_project_name, $t_title );
        $t_title = str_replace( '%%new_project%%', project_get_field( $t_project['id'], 'name' ), $t_title );
        for( $i=0;$i<$t_project['level'];$i++ ) {
	    echo '&nbsp; ';
	}
	echo '<a href="set_project.php?ref=' . urlencode( 'plugins_page.php?plugin=hierarchy&display=hierarchy' ) . '&project_id=' . $t_project['id'] . '" title="' . $t_title . '">';
	echo string_display( project_get_field( $t_project['id'], 'name' ) ) . '</a><br />' . "\n";
	
	$t_mantis_project_category_table = config_get( 'mantis_project_category_table' );
	
	$cat_arr = array();
	$t_id = $t_project['id'];
	$query = "SELECT DISTINCT( category ) as category
        	  FROM $t_mantis_project_category_table
                  WHERE project_id='$t_id'
                  ORDER BY category";
	$result = db_query( $query );
	$category_count = db_num_rows( $result );
	for ($j=0;$j<$category_count;$j++) {
	    $row = db_fetch_array( $result );
	    $cat_arr[] = string_attribute( $row['category'] );
	}
	sort( $cat_arr );
	$cat_arr = array_unique( $cat_arr );
	
	foreach( $cat_arr as $t_category ) {
	    for( $i=0;$i<$t_project['level'];$i++ ) {
		echo '&nbsp; ';
	    }
	    echo "&nbsp; - $t_category<br />\n";
	}
    }
}

?>
