<?php

/**
 * Hierarchy plugin
 *
 *
 * Created: 2007-01-30
 * Last update: 2007-02-16
 *
 * @link http://deboutv.free.fr/mantis/
 * @copyright 
 * @author DEBOUT Vincent  <deboutv@free.fr>
 * @package Hierarchy
 * @version 0.0.1
 */

if ( !ereg( 'plugins_page.php', $_SERVER['REQUEST_URI'] ) ) {
    header( 'Location: ../../plugins_page.php' );
    exit();
}

$t_display = gpc_get_string( 'display', 'config' );

if ( $t_display == 'config' ) {

    require( dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'core' . DIRECTORY_SEPARATOR . 'hierarchy_api.php' );

    auth_ensure_user_authenticated();

    $t_current_user_id = auth_get_current_user_id();

    $t_action = gpc_get_string( 'action', 'none' );
    if ( $t_action == 'update' ) {
        $t_show_managers = gpc_get_bool( 'show_managers' );
        $t_show_developers = gpc_get_bool( 'show_developers' );
        $t_title = gpc_get_string( 'title' );
        config_set( 'plugins_hierarchy_show_managers', $t_show_managers, NO_USER, ALL_PROJECTS );
        config_set( 'plugins_hierarchy_show_developers', $t_show_developers, NO_USER, ALL_PROJECTS );
        config_set( 'plugins_hierarchy_title', $t_title, NO_USER, ALL_PROJECTS );
        header( 'Location: plugins_page.php?plugin=hierarchy' );
        exit();
    }

    $t_project_id = helper_get_current_project();

    html_page_top1( lang_get( 'plugins_hierarchy_configuration_page_title' ) );
    html_page_top2();

?>

<br />
<div align="center">
<?php

  echo str_replace( '%%project%%', '<b>' . project_get_name( helper_get_current_project() ) . '</b>', lang_get( 'plugins_hierarchy_configuration_for_project' ) );

?>
  <br /><br />
  <form name="plugins_hierarchy" method="post" action="plugins_page.php">
    <input type="hidden" name="action" value="update" />
    <input type="hidden" name="project_id" value="<?php echo $t_project_id ?>" />
    <input type="hidden" name="plugin" value="hierarchy" />
    <table class="width75" cellspacing="1">

      <!-- Title -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <span class="required">*</span><?php echo lang_get( 'plugins_hierarchy_title' ); ?>
        </td>
        <td width="70%">
          <input tabindex="1" type="text" size="50" name="title" value="<?php echo config_get( 'plugins_hierarchy_title', PLUGINS_HIERARCHY_TITLE_DEFAULT ); ?>" />
        </td>
      </tr>

      <!-- spacer -->
      <tr>
        <td class="spacer" colspan="2">&nbsp;</td>
      </tr>
    
      <!-- Show managers -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <span class="required">*</span><?php echo lang_get( 'plugins_hierarchy_show_managers' ); ?>
        </td>
        <td width="70%">
          <input tabindex="2" type="checkbox" name="show_managers"<?php check_checked( config_get( 'plugins_hierarchy_show_managers', PLUGINS_HIERARCHY_SHOW_MANAGERS_DEFAULT ), ON ) ?> />
        </td>
      </tr>

      <!-- Show developers -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <span class="required">*</span><?php echo lang_get( 'plugins_hierarchy_show_developers' ); ?>
        </td>
        <td width="70%">
          <input tabindex="3" type="checkbox" name="show_developers"<?php check_checked( config_get( 'plugins_hierarchy_show_developers', PLUGINS_HIERARCHY_SHOW_DEVELOPERS_DEFAULT ), ON ) ?> />
        </td>
      </tr>

      <!-- Submit Button -->
      <tr>
        <td class="left">
          <span class="required"> * <?php echo lang_get( 'required' ) ?></span>
        </td>
        <td class="center">
          <input tabindex="4" type="submit" class="button" value="<?php echo lang_get( 'submit_button' ) ?>" />
        </td>
      </tr>

    </table>
  </form>

</div>

<?php

  html_page_bottom1( __FILE__ );
} else {
    auth_ensure_user_authenticated();

    $t_current_user_id = auth_get_current_user_id();

    $t_main_menu = config_get( 'main_menu_custom_options' );
    $t_access_level = ADMINISTRATOR;
    foreach( $t_main_menu as $t_menu ) {
        if ( ereg( 'plugins_page.php\?plugin=hierarchy&display=hierarchy', $t_menu[2] ) ) {
            $t_access_level = $t_menu[1];
        }
    }

    if ( user_get_access_level( $t_current_user_id ) < $t_access_level ) {
        header( 'Location: index.php' );
        exit();
    }

    require( dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'core' . DIRECTORY_SEPARATOR . 'hierarchy_api.php' );

    html_page_top1( config_get( 'plugins_hierarchy_title', PLUGINS_HIERARCHY_TITLE_DEFAULT ) );

    if ( current_user_get_pref( 'refresh_delay' ) > 0 ) {
        html_meta_redirect( 'plugins_page.php?plugin=hierarchy&display=hierarchy', current_user_get_pref( 'refresh_delay' ) * 60 );
    }
    html_page_top2();
    echo '<br /><div align="center"><span class="pagetitle">', config_get( 'plugins_hierarchy_title', PLUGINS_HIERARCHY_TITLE_DEFAULT ), '</span><br /><br />';

    if ( config_get( 'plugins_hierarchy_show_managers', PLUGINS_HIERARCHY_SHOW_MANAGERS_DEFAULT ) == ON && config_get( 'plugins_hierarchy_show_developers', PLUGINS_HIERARCHY_SHOW_DEVELOPERS_DEFAULT ) == ON ) {
        echo '<table style="width: 95%; border: solid 1px #000000;" cellspacing="1">';
    } elseif ( config_get( 'plugins_hierarchy_show_managers', PLUGINS_HIERARCHY_SHOW_MANAGERS_DEFAULT ) == ON || config_get( 'plugins_hierarchy_show_developers', PLUGINS_HIERARCHY_SHOW_DEVELOPERS_DEFAULT ) == ON ) {
        echo '<table style="width: 70%; border: solid 1px #000000;" cellspacing="1">';
    } else {
        echo '<table style="width: 65%; border: solid 1px #000000;" cellspacing="1">';
    }
?>
<!-- Title -->
<tr>
        <td class="form-title">
                <?php echo lang_get( 'plugins_hierarchy_projects' ) ?>
        </td>
<?php if ( config_get( 'plugins_hierarchy_show_managers', PLUGINS_HIERARCHY_SHOW_MANAGERS_DEFAULT ) == ON ) { ?>
	<td class="right">
		<?php echo lang_get( 'plugins_hierarchy_managers' ) ?>
	</td>
<?php } ?>
<?php if ( config_get( 'plugins_hierarchy_show_developers', PLUGINS_HIERARCHY_SHOW_DEVELOPERS_DEFAULT ) == ON ) { ?>
	<td class="right">
		<?php echo lang_get( 'plugins_hierarchy_developers' ) ?>
	</td>
<?php } ?>
        <td class="right">
                <?php echo lang_get( 'plugins_hierarchy_description' ) ?>
        </td>
</tr>

<?php
	$t_project_ids = current_user_get_accessible_projects();
        $t_project_count = count( $t_project_ids );
        for ($i=0;$i<$t_project_count;$i++) {
        	$t_id = $t_project_ids[$i];

?>
<tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
<?php

     display_project_cell( $t_id );
		
?>
     
     </td>
<?php
  if ( config_get( 'plugins_hierarchy_show_managers', PLUGINS_HIERARCHY_SHOW_MANAGERS_DEFAULT ) == ON ) {
      echo '<td width="25%">' . "\n";
      display_manager_cell( $t_id );
      echo "</td>\n";
  }		
?>
<?php
  if ( config_get( 'plugins_hierarchy_show_developers', PLUGINS_HIERARCHY_SHOW_DEVELOPERS_DEFAULT ) == ON ) {
      echo '<td width="25%">' . "\n";
      display_developer_cell( $t_id );
      echo "</td>\n";
  }		
?>
     <td width="45%">
<?php

  display_description_cell( $t_id );

?>
     </td>
</tr>

<?php
        }
?>
</table>
<?php
    echo '</div>';
    html_page_bottom1( __FILE__ );
}

?>
